/* Copyright (C) 2000-2006 MySQL AB

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include <stdio.h>
#include <string.h>

void _hash_mysql323(unsigned long int *result, const char *password, unsigned long int password_len)
{
    unsigned long int nr=1345345333L, add=7, nr2=0x12345671L, tmp;

    const char *password_end= password + password_len;
    for (; password < password_end; password++)
    {
	if (*password == ' ' || *password == '\t')
	continue;                                 /* skip space in password */
	tmp= (unsigned long int) (unsigned char) *password;
	nr^= (((nr & 63)+add)*tmp)+ (nr << 8);
	nr2+=(nr2 << 8) ^ nr;
	add+=tmp;
    }
    result[0]=nr & (((unsigned long int) 1L << 31) -1L); /* Don't use sign bit (str2int) */;
    result[1]=nr2 & (((unsigned long int) 1L << 31) -1L);
}
